package org.remote.roadhog;

import java.awt.*;
import java.applet.*;
import java.awt.event.*;

public class MapApplet extends Applet 
{

	private Image photo = null;
	private java.util.Hashtable maps = new java.util.Hashtable ();
	private int maprows = 0;
	private int mapcols = 0;
	private int markerx = 0;
	private int markery = 0;
	private Image mapImage[][] = null;
	private int colwidth[] = null;
	private int rowheight[] = null;
	private int photox = 0;
	private boolean updating = false;
	private Observer observer = new Observer ();
	private int heading = 0;
	private String largephoto = null;

	
	public MapApplet ()
	{
		addMouseListener (new java.awt.event.MouseAdapter () {
			public void mouseClicked (java.awt.event.MouseEvent e) {
				if ((e.getPoint().x >= photox) && (largephoto != null))
				{
					// System.out.println ("show "+largephoto);
					getAppletContext ().showDocument (makeURL (largephoto), "_new");
				}
			};
		});
	}

	/**
	 * Helper to create valid URLs.
	 */
	public java.net.URL makeURL (String relative)
	{
		String working;
		try 
		{
			working = getCodeBase ().toString ();
		}
		catch (Exception x)
		{
			return null;
			
		}

		int questionMark = working.indexOf ("?");
		if (questionMark > -1)
		{
			working = working.substring (0, questionMark);
		}

		int lastSlash = working.lastIndexOf ("/");
		if ((lastSlash < working.length ()) && (lastSlash > -1))
		{
			working = working.substring (0, lastSlash + 1);
		}

		try
		{
			return new java.net.URL (working + relative);
		}
		catch (java.net.MalformedURLException x)
		{
			x.printStackTrace ();
		}
		return (null);
	}

	/**
	 * Updates photo.
	 */
	public void updatePhoto (String imgname, String large)
	{
		// System.out.println (getCodeBase());
		photo = getImage (makeURL(imgname));
		largephoto = large;
		repaint ();
	}

	/**
	 * Updates map display.
	 */
	public void updateMap (String map)
	{
		// System.out.println ("update map: "+map);
		java.util.StringTokenizer t = new java.util.StringTokenizer (map, ",");
		try
		{
			maprows = Integer.parseInt (t.nextToken ());
			mapcols = Integer.parseInt (t.nextToken ());
			markerx = Integer.parseInt (t.nextToken ());
			markery = Integer.parseInt (t.nextToken ());
			heading = Integer.parseInt (t.nextToken ());
			updating = true;
			if ((mapImage == null) || (colwidth == null) || (rowheight == null) ||
				(colwidth.length != mapcols) || (rowheight.length != maprows))
			{
				mapImage = new Image[maprows][mapcols];
				colwidth = new int[mapcols];
				rowheight = new int[maprows];
			}
			String basemname = t.nextToken ();

			for (int i=-1; i<maprows; i++)
			for (int j=-1; j<mapcols; j++)
			{
				if (i==-1)
				{
					if (j>-1) colwidth[j]=Integer.parseInt (t.nextToken ());
				}
				else if (j==-1)
				{
					rowheight[i] = Integer.parseInt (t.nextToken ());
				}
				else
				{
					String mname = t.nextToken ();
					mapImage[i][j] = (Image) maps.get (mname);
					if (mapImage[i][j] == null)
					{
						mapImage[i][j] = getImage (makeURL(basemname + "/" + mname + ".gif"));
						maps.put (mname, mapImage[i][j]);
					}
				}
			}
			photox = 10;
			for (int i=0; i<mapcols; i++) photox += colwidth[i];

		}
		catch (Exception x)
		{
			x.printStackTrace ();
		}
		updating = false;
		repaint ();
	}

	/**
	 * Paints map, image, and red dot.
	 */
	public void paint (Graphics g)
	{
		int x = 0, y = 0;
		if (updating) return;
		try
		{
			for (int i=0; i<maprows; i++)
			for (int j=0; j<mapcols; j++)
			{
				if (mapImage[i][j] != null) g.drawImage (mapImage[i][j], x, y, observer);
				if (j==(mapcols-1))
				{
					y += rowheight[j];
					x = 0;
				}
				else
				{
					x += colwidth[j];
				}
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace ();
		}

		if (photo != null) g.drawImage (photo, photox, 0, observer);

		/*
		failed attempt at arrow painting - try again later.

		int aw=4;
		Polygon p = new Polygon ();
		p.addPoint (0,-aw);
		p.addPoint (3*aw,-aw);
		p.addPoint (3*aw,-2*aw);
		p.addPoint (4*aw,0);
		p.addPoint (3*aw,2*aw);
		p.addPoint (3*aw,aw);
		p.addPoint (0, aw);

		double cost = Math.cos (heading / 2 / Math.PI);
		double sint = Math.sin (heading / 2 / Math.PI);

		for (int i=0; i<p.npoints; i++)
		{
			p.xpoints[i] = (int) (p.xpoints[i] * cost - p.ypoints[i] * sint + 0.5) + markery;
			p.ypoints[i] = (int) (p.xpoints[i] * sint + p.ypoints[i] * cost + 0.5) + markery;
		}
		*/

		g.setColor (Color.black);
		g.fillOval (markerx-5,markery-5,10,10);
		g.setColor (Color.red);
		g.fillOval (markerx-4,markery-4,8,8);
		/*
		g.setColor (Color.yellow);
		g.fillPolygon (p);
		*/
	}

	/**
	 * Initializes display from <param> tags.
	 */
	public void init ()
	{
		setBackground (Color.white);
		updateMap (getParameter ("map"));
		updatePhoto (getParameter ("photo"), getParameter ("zoom"));
	}

	public void update (Graphics g)
	{
		paint (g);
	}

	private class Observer implements java.awt.image.ImageObserver 
	{
		public boolean imageUpdate(Image img, int infoflags, int x, int y, int w, int h) 
		{ 
			if ((infoflags & java.awt.image.ImageObserver.ALLBITS) != 0)
			{
				repaint ();
				return false;
			}
			if ((infoflags & java.awt.image.ImageObserver.SOMEBITS) != 0)
			{
				MapApplet.this.repaint ();
			}
			return true;
		}
	}
}



