
package org.remote.roadhog;

import org.w3c.dom.*;
import java.io.PrintStream;
import java.util.*;
import java.awt.*;

public abstract class XMLObject
{
	private HashMap attribute = new HashMap ();
	public static String getTextChild (Node n)
	{
		NodeList c = n.getChildNodes ();
		if ((c.getLength () != 1) || (c.item (0).getNodeType () != Node.TEXT_NODE))
			return "";
		return c.item (0).getNodeValue ();
	}
	public String stringToXML (String s)
	{
		return s; /* later */
	}
	public abstract void toXML (PrintStream o, String indent);
	public void toXML (PrintStream o) { toXML (o, ""); }

	public void setOutputAttribute (String attr, String value)
	{
		attribute.put (attr, value);
	}
	protected String getOutputAttributes ()
	{
		StringBuffer rv = new StringBuffer();
		for (Iterator i = attribute.entrySet ().iterator (); i.hasNext (); )
		{
			java.util.Map.Entry e = (java.util.Map.Entry) i.next ();
			rv.append (e.getKey ()); rv.append ("="); rv.append (e.getValue ());
		}
		if (rv.length () > 0) rv.insert (0, " ");
		return (rv.toString ());
	}

	/**
	 * From the given element, takes all children with tag name "name" and
	 * sorts them into "target", using the "language" attribute as key;
	 * defaults to "en" of none set.
	 */
	protected void parseAttributeWithLanguage (Element el, String name, HashMap target)
	{
        NodeList sublist = el.getElementsByTagName (name);
        for (int i=0; i<sublist.getLength (); i++)
        {
            String value = getTextChild (sublist.item(i));
            String lang = ((Element) sublist.item(i)).getAttribute ("language");
			target.put (lang, value);
		}
	}

	/**
	 * The opposite to parseAttributeWithLanguage.
	 */
	public void writeAttributeWithLanguage (PrintStream o, String indent, String name, HashMap m)
	{
		for (Iterator i = m.keySet ().iterator (); i.hasNext (); )
		{
			String lang = (String) i.next ();
			o.print (indent + "<"+name+" language=\"" + lang + "\">");
			o.print (stringToXML ((String) m.get (lang)));
			o.println ("</" + name + ">");
		}
	}

	public String getAttributeInLanguage (HashMap attr, String lang)
	{
		String rv = (String) attr.get (lang);
		if (rv == null) rv = (String) attr.get ("*");
		return rv;
	}

	interface XMLObjectLookup 
	{
		public Object findObject (Class theClass, String id);
	}

	// TODO error handling
	public Point parsePoint (Element n)
	{
		NodeList sublist;
		sublist = n.getElementsByTagName ("x");
		if (sublist.getLength () == 1)
		{
			int x = Integer.parseInt (getTextChild (sublist.item (0)));
			sublist = n.getElementsByTagName ("y");
			if (sublist.getLength () == 1)
			{
				int y = Integer.parseInt (getTextChild (sublist.item (0)));
				return (new Point (x, y));
			}
		}
		return null;
	}

	public Rectangle parseRect (Element n)
	{
		NodeList sublist;
		sublist = n.getElementsByTagName ("x");
		if (sublist.getLength () == 1)
		{
			int x = Integer.parseInt (getTextChild (sublist.item (0)));
			sublist = n.getElementsByTagName ("y");
			if (sublist.getLength () == 1)
			{
				int y = Integer.parseInt (getTextChild (sublist.item (0)));
				sublist = n.getElementsByTagName ("width");
				if (sublist.getLength () == 1)
				{
					int width = Integer.parseInt (getTextChild (sublist.item (0)));
					sublist = n.getElementsByTagName ("height");
					if (sublist.getLength () == 1)
					{
						int height = Integer.parseInt (getTextChild (sublist.item (0)));
						return (new Rectangle (x, y, width, height));
					}
				}
			}
		}
		return null;
	}

	public static String dumpBytes(byte[] bytes) {
		int i;
		StringBuffer sb = new StringBuffer();
		for (i=0; i<bytes.length; i++) {
			if (i%32 == 0 && i!=0) {
				sb.append("\n");
			}
			String s = Integer.toHexString(bytes[i]);
			if (s.length() < 2) {
				s = "0"+s;
			}
			if (s.length() > 2) {
				s = s.substring(s.length()-2);
			}
			sb.append(s);
		}
		return sb.toString();
	}

}

